 /**    
  *******************************************************************************************************   
  * @attention    
  * Copyright (c) 2023, SHANGHAI FUDAN MICROELECTRONICS GROUP CO., LTD.(FUDAN MICROELECTRONICS./ FUDAN MICRO.)    
  * All rights reserved.    
  *    
  * Processor:                   FM33LF0xxA    
  * http:                        http://www.fmdevelopers.com.cn/    
  *    
  * Redistribution and use in source and binary forms, with or without    
  * modification, are permitted provided that the following conditions are met    
  *    
  * 1. Redistributions of source code must retain the above copyright notice,    
  *    this list of conditions and the following disclaimer.    
  *    
  * 2. Redistributions in binary form must reproduce the above copyright notice,    
  *    this list of conditions and the following disclaimer in the documentation    
  *    and/or other materials provided with the distribution.    
  *    
  * 3. Neither the name of the copyright holder nor the names of its contributors    
  *    may be used to endorse or promote products derived from this software    
  *    without specific prior written permission.    
  *    
  * 4. To provide the most up-to-date information, the revision of our documents     
  *    on the World Wide Web will be the most Current. Your printed copy may be      
  *    an earlier revision. To verify you have the latest information avaliable,    
  *    refer to: http://www.fmdevelopers.com.cn/.    
  *    
  * THIS SOFTWARE IS PROVIDED BY FUDAN MICRO "AS IS" AND ANY EXPRESSED:     
  * ORIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES     
  * OF MERCHANTABILITY NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE    
  * ARE DISCLAIMED.IN NO EVENT SHALL FUDAN MICRO OR ITS CONTRIBUTORS BE LIABLE     
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL     
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     
  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER    
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,     
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISINGIN ANY WAY OUT OF THE     
  * USE OF THIS SOFTWARE, EVEN IF ADVISED OFTHE POSSIBILITY OF SUCH DAMAGE.  
  *
  ******************************************************************************************************* 
  */ 

#ifndef __LED_H__
#define __LED_H__

#include "fm33lf0xxa_fl.h"

#define LED1_GPIO        GPIOC
#define LED1_PIN         FL_GPIO_PIN_0
  
#define LED2_GPIO        GPIOC
#define LED2_PIN         FL_GPIO_PIN_1

#define LED3_GPIO        GPIOC
#define LED3_PIN         FL_GPIO_PIN_13

#define LED4_GPIO        GPIOB
#define LED4_PIN         FL_GPIO_PIN_15


/*----------LED1(需要跳冒J42)----------------------------------------------------*/
#define LED1_ON()   do{FL_GPIO_ResetOutputPin(LED1_GPIO, LED1_PIN);}while(0)
#define LED1_OFF()  do{FL_GPIO_SetOutputPin(LED1_GPIO, LED1_PIN);}while(0)
#define LED1_TOG()  do{FL_GPIO_ToggleOutputPin(LED1_GPIO, LED1_PIN);}while(0)
#define LED1_INIT() do{\
                             FL_GPIO_InitTypeDef    GPIO_InitStruct;\
                             GPIO_InitStruct.pin           = LED1_PIN;\
                             GPIO_InitStruct.mode          = FL_GPIO_MODE_OUTPUT;\
                             GPIO_InitStruct.outputType    = FL_GPIO_OUTPUT_PUSHPULL;\
                             GPIO_InitStruct.pull          = FL_GPIO_BOTH_DISABLE;\
                             GPIO_InitStruct.analogSwitch = FL_DISABLE;\
                             GPIO_InitStruct.remapPin      = FL_GPIO_PINREMAP_FUNCTON1;\
                             GPIO_InitStruct.driveStrength = FL_GPIO_DRIVESTRENGTH_X3;\
                             (void)FL_GPIO_Init(LED1_GPIO, &GPIO_InitStruct );\
                         }while(0)

/*----------LED2-----------------------------------------------------------*/
#define LED2_ON()     do{FL_GPIO_ResetOutputPin(LED2_GPIO, LED2_PIN);}while(0)
#define LED2_OFF()    do{FL_GPIO_SetOutputPin(LED2_GPIO, LED2_PIN);}while(0)
#define LED2_TOG()    do{FL_GPIO_ToggleOutputPin(LED2_GPIO, LED2_PIN);}while(0)
#define LED2_INIT()   do{\
                             FL_GPIO_InitTypeDef    GPIO_InitStruct;\
                             GPIO_InitStruct.pin           = LED2_PIN;\
                             GPIO_InitStruct.mode          = FL_GPIO_MODE_OUTPUT;\
                             GPIO_InitStruct.outputType    = FL_GPIO_OUTPUT_PUSHPULL;\
                             GPIO_InitStruct.pull          = FL_GPIO_BOTH_DISABLE;\
                             GPIO_InitStruct.analogSwitch = FL_DISABLE;\
                             GPIO_InitStruct.remapPin      = FL_GPIO_PINREMAP_FUNCTON1;\
                             GPIO_InitStruct.driveStrength = FL_GPIO_DRIVESTRENGTH_X3;\
                             (void)FL_GPIO_Init(LED2_GPIO, &GPIO_InitStruct );\
                         }while(0)
    
/*----------LED3----------------------------------------------------------*/
#define LED3_ON()    do{FL_GPIO_ResetOutputPin(LED3_GPIO, LED3_PIN);}while(0)
#define LED3_OFF()   do{FL_GPIO_SetOutputPin(LED3_GPIO, LED3_PIN);}while(0)
#define LED3_TOG()   do{FL_GPIO_ToggleOutputPin(LED3_GPIO, LED3_PIN);}while(0)
#define LED3_INIT()  do{\
                             FL_GPIO_InitTypeDef    GPIO_InitStruct;\
                             GPIO_InitStruct.pin           = LED3_PIN;\
                             GPIO_InitStruct.mode          = FL_GPIO_MODE_OUTPUT;\
                             GPIO_InitStruct.outputType    = FL_GPIO_OUTPUT_PUSHPULL;\
                             GPIO_InitStruct.pull          = FL_GPIO_BOTH_DISABLE;\
                             GPIO_InitStruct.analogSwitch = FL_DISABLE;\
                             GPIO_InitStruct.remapPin      = FL_GPIO_PINREMAP_FUNCTON1;\
                             GPIO_InitStruct.driveStrength = FL_GPIO_DRIVESTRENGTH_X3;\
                             (void)FL_GPIO_Init(LED3_GPIO, &GPIO_InitStruct );\
                         }while(0)

/*----------LED4(需要跳冒J43)-----------------------------------------------------*/
#define LED4_OFF()   do{FL_GPIO_SetOutputPin(LED4_GPIO, LED4_PIN);}while(0)
#define LED4_ON()    do{FL_GPIO_ResetOutputPin(LED4_GPIO, LED4_PIN);}while(0)
#define LED4_TOG()   do{FL_GPIO_ToggleOutputPin(LED4_GPIO, LED4_PIN);}while(0)
#define LED4_INIT()  do{\
                                     FL_GPIO_InitTypeDef    GPIO_InitStruct;\
                                     GPIO_InitStruct.pin           = LED4_PIN;\
                                     GPIO_InitStruct.mode          = FL_GPIO_MODE_OUTPUT;\
                                     GPIO_InitStruct.outputType    = FL_GPIO_OUTPUT_PUSHPULL;\
                                     GPIO_InitStruct.pull          = FL_GPIO_BOTH_DISABLE;\
                                     GPIO_InitStruct.analogSwitch = FL_DISABLE;\
                                     GPIO_InitStruct.remapPin      = FL_GPIO_PINREMAP_FUNCTON1;\
                                     GPIO_InitStruct.driveStrength = FL_GPIO_DRIVESTRENGTH_X3;\
                                     (void)FL_GPIO_Init(LED4_GPIO, &GPIO_InitStruct );\
                                  }while(0)


/* LED1 */
/* LED2 */
/* LED3 */
/* LED4 */
#define LED_ON(X)        do{LED_##X##_ON();  LED_##X##_INIT();}while(0)
#define LED_OFF(X)       do{LED_##X##_OFF(); LED_##X##_INIT();}while(0)
#define LED_TOG(X)       do{LED_##X##_TOG(); LED_##X##_INIT();}while(0)
#define LED_TOG_FUN(COLOUR, TIMES, CALL_BACK)\
                         do{uint32_t i = (TIMES);\
                            do{LED_ON(COLOUR);(CALL_BACK);LED_OFF(COLOUR);(CALL_BACK);}while(--i);\
                           }while(0)
                             
#endif

